// Event1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Event1.h"
#include "Event1Dlg.h"

#include "..\..\include\AdamTcpCE.h"

UINT ThreadProc( LPVOID lpParam );

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEFAULT_PORT 502  // Port for Modbus/TCP
#define  DeviceID       0x01  // 0x01 indicate the 5000/TCP
//-------- default timeout ------
int     iConnectionTimeout=2000;
int     iSendTimeout=2000;
int     iReceiveTimeout=2000;

wchar_t	szwIPAddress[20];

int MbsToWcs (char* mbs, wchar_t* wcs);
int WcsToMbs (wchar_t* wcs, char* mbs);

//----------------------------------------------
struct _StreamData   *pStreamData,StreamData;
static BYTE byLoopFlag=1;
HANDLE    hEvent;

int MbsToWcs (char* mbs, wchar_t* wcs)
{
	wchar_t g_wcConverter[256];
	size_t len = strlen (mbs);
	memset (g_wcConverter, 0, sizeof(g_wcConverter));
	if (len > 127) return NULL;
	mbstowcs(g_wcConverter, mbs, len);
	wcscpy(wcs, g_wcConverter);
	return len;
}

int WcsToMbs (wchar_t* wcs, char* mbs)
{
	char	g_mbConvert[256];
	size_t len = wcslen (wcs);
	if (len >= sizeof(g_mbConvert)) len = sizeof(g_mbConvert) - 1;
	wcstombs(g_mbConvert, wcs, len);
	strcpy(mbs, g_mbConvert);
	return len;
}

/////////////////////////////////////////////////////////////////////////////
// CEvent1Dlg dialog

CEvent1Dlg::CEvent1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEvent1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEvent1Dlg)
	m_strIPAddress = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEvent1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEvent1Dlg)
	DDX_Text(pDX, IDC_EDIT_IPADDRESS, m_strIPAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEvent1Dlg, CDialog)
	//{{AFX_MSG_MAP(CEvent1Dlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEvent1Dlg message handlers

BOOL CEvent1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_strIPAddress="172.18.1.41";
	SetDlgItemText(IDC_EDIT_IPADDRESS,m_strIPAddress);

	// get the DLL version 
	char     szCh[20];
    int    iVersion;    
 
	iVersion=ADAMTCP_GetDLLVersion();
	_ltoa( iVersion, szCh, 16 );

	size_t len = strlen (szCh);
	wchar_t  wcConverter[20];

	memset (wcConverter, 0, sizeof(wcConverter));

	mbstowcs(wcConverter, szCh, len);
	//wsprintf(szwCh,"%s",szCh);
	SetDlgItemText(IDC_EDIT_DLLVER, wcConverter);

    //--- To initialize DLL to work ---
    int   iRetVal;

    iRetVal=ADAMTCP_Open();
    if( iRetVal!=0 )
    {
        MessageBox( _T("ADAMTCP_Open() Failure !!!") );
    }

    (CButton *)GetDlgItem(IDC_STOP)->EnableWindow( FALSE );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CEvent1Dlg::OnExit() 
{
	// TODO: Add your control notification handler code here
    ADAMTCP_Close();
	
	// TODO: Add your control notification handler code here
	CDialog::OnOK();	
}

void CEvent1Dlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	int       iRetVal; 
    CString   strText,strTemp;

	(CButton *)GetDlgItem(IDC_START)->EnableWindow( FALSE );
	(CButton *)GetDlgItem(IDC_STOP)->EnableWindow( TRUE );
	(CButton *)GetDlgItem(IDC_EXIT)->EnableWindow( FALSE );

	m_bStopThread = FALSE;
	m_pThread = NULL;

    m_iTotalReceive=0;
    m_iTotalTimeout=0;
    m_iThreadIndex=0;

    // get the 5000/TCP's IP Address
	GetDlgItemText(IDC_EDIT_IPADDRESS,szwIPAddress,20);

    //-----  create a event for synchronization ---------------
    hEvent = CreateEvent(NULL,
			     FALSE,   // auto reset
			     FALSE,  // init state as Non-Signal
			     NULL);

    //--- adding the first 5000/TCP for streaming ----
    iRetVal=ADAMTCP_Add5KTCPForStream(szwIPAddress);
    if( iRetVal<0 )
    {
		MessageBox( _T("ADAMTCP_Add5KTCPForStream() Failure !!!") );
    }

	((CListBox*)GetDlgItem(IDC_LIST_STREAM))->ResetContent();
    m_pListBox=(CListBox*)GetDlgItem(IDC_LIST_STREAM);

	if( m_pThread == NULL )
	{
		m_ThreadData.hEvent = &hEvent;
		m_ThreadData.lpStopThread = &m_bStopThread;
		m_ThreadData.TotalReceive=&m_iTotalReceive;
        m_ThreadData.TotalTimeout=&m_iTotalTimeout;
        m_ThreadData.ThreadIndex=&m_iThreadIndex;
		m_ThreadData.pListBox=m_pListBox;
  	    // Start the thread.
		m_pThread =
			AfxBeginThread(ThreadProc, (LPVOID) &m_ThreadData);
	}

    //--- Starting to receive the streaming data come from 5000/TCP ---
    ADAMTCP_StartStream( &hEvent);	
}

void CEvent1Dlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	HANDLE hThread = m_pThread->m_hThread;

	// Set the flag to kill the thread to TRUE;
    m_bStopThread = TRUE;

	// Wait for the thread to end.
	::WaitForSingleObject( hThread, 1000 );

    //--- Stop receiving the streaming data come from 5000/TCP ---	
	ADAMTCP_StopStream( );
    //--- Close the event handle ---
    CloseHandle(hEvent);

	(CButton *)GetDlgItem(IDC_START)->EnableWindow( TRUE );
	(CButton *)GetDlgItem(IDC_STOP)->EnableWindow( FALSE );
	(CButton *)GetDlgItem(IDC_EXIT)->EnableWindow( TRUE );

    m_iTotalReceive=0;
    m_iTotalTimeout=0;
    m_iThreadIndex=0;	
}

UINT ThreadProc( LPVOID lpParam )
{
	THREAD_DATA *lpThreadData =(THREAD_DATA *) lpParam;
	int    iRetVal;
    CString   strText; 
	//char   szCh[20];

	while( !(*lpThreadData->lpStopThread) )
	{
		*lpThreadData->ThreadIndex=101;
	    if(WaitForSingleObject(*lpThreadData->hEvent,1000)==WAIT_OBJECT_0)  // waiting for 5 seconds
	    { 		
			   if( (*lpThreadData->TotalReceive)%3==2 )
			   {
				   (lpThreadData->pListBox)->ResetContent();
			   }
			   (*lpThreadData->TotalReceive)++;

               iRetVal=ADAMTCP_ReadStreamData(szwIPAddress,&StreamData);
               pStreamData=(struct _StreamData *)&StreamData;

		       strText.Format( _T("Receive:%d"), *lpThreadData->TotalReceive);
		       (lpThreadData->pListBox)->InsertString( -1, strText );
			  
	           strText.Format (_T("DI/DO data of Slot0 to Slot 7:") );
			   (lpThreadData->pListBox)->InsertString( -1, strText );
			   strText.Format(_T("%04x:%04x:%04x:%04x-%04x:%04x:%04x:%04x"),StreamData.DIO[0],StreamData.DIO[1],
							       StreamData.DIO[2],StreamData.DIO[3],
							       StreamData.DIO[4],StreamData.DIO[5],	
							       StreamData.DIO[6],StreamData.DIO[7]);
			   (lpThreadData->pListBox)->InsertString( -1, strText );
			   strText.Format(_T("AI/Ao data of Slot0:") );
			   (lpThreadData->pListBox)->InsertString( -1, strText );
               strText.Format(_T("%04x:%04x:%04x:%04x-%04x:%04x:%04x:%04x"),StreamData.Slot0[0],StreamData.Slot0[1],
							       StreamData.Slot0[2],StreamData.Slot0[3],
							       StreamData.Slot0[4],StreamData.Slot0[5],
							       StreamData.Slot0[6],StreamData.Slot0[7]);	
			   (lpThreadData->pListBox)->InsertString( -1, strText );
			   strText.Format(_T("AI/AO data of Slot1:"));
			   (lpThreadData->pListBox)->InsertString( -1, strText );
               strText.Format(_T("%04x:%04x:%04x:%04x-%04x:%04x:%04x:%04x"),StreamData.Slot1[0],StreamData.Slot1[1],
							       StreamData.Slot1[2],StreamData.Slot1[3],
							       StreamData.Slot1[4],StreamData.Slot1[5],
							       StreamData.Slot1[6],StreamData.Slot1[7]);			
			   (lpThreadData->pListBox)->InsertString( -1, strText );
               

		}
		else
		{
			(*lpThreadData->TotalTimeout)++;
		}

	}
	(*lpThreadData->ThreadIndex)=102;
	return 0;
}

